//
//  ViewController.m
//  AipOcrDemo
//
//  Created by chenxiaoyu on 17/2/7.
//  Copyright © 2017年 baidu. All rights reserved.
//

#import "OcrViewController.h"
#import <objc/runtime.h>
#import "AipOcrService.h"
#import "AipGeneralVC.h"
#import "AipCaptureCardVC.h"
#import <cepmSdk/cepmSdk.h>

static Credential * CREDENTIAL;

@interface OcrViewController ()<UITableViewDelegate, UITableViewDataSource, UIAlertViewDelegate>

@property (weak, nonatomic) IBOutlet UITableView *tableView;

@property (nonatomic, strong) NSMutableArray<NSArray<NSString *> *> *actionList;

@end

@implementation OcrViewController {
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [self configureView];
    [self configureData];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [self updateTableView];
}

- (void)configureView {
    
    self.title = @"OCR能力展示";
}

- (void)configureData {
    //1. 初始化用户凭证
    CREDENTIAL = [[Credential alloc]init];
    CREDENTIAL.sysName = @"jkrf";
    CREDENTIAL.password = @"xrwZD376AXHDgWde6s2bkZ6P7TaexhzAja7XoOMX8nOq3TaDqFHi73fAuBMj04lu9TvDTD1HhKQHRTcoRDxgCXvFwtF9+6kj5UUsH9A8NiEBh8MuVjQC61qV7cM9j2gH+myeWBEInCHOsJXDrB7ADxLrZMuIG+feoGwsEw7xyVI=";
    CREDENTIAL.userCode = @"v001";
    CREDENTIAL.url = @"https://cepmtest.dhcccloud.com.cn/gateway";
    //2. 为OCR服务设置用户凭证
    [AipOcrService setCredential:CREDENTIAL];
    
    self.actionList = [NSMutableArray array];
    
    [self.actionList addObject:@[@"身份证正面拍照识别", @"idcardOCROnlineFront"]];
    [self.actionList addObject:@[@"身份证反面拍照识别", @"idcardOCROnlineBack"]];
    [self.actionList addObject:@[@"身份证正面(嵌入式质量控制+云端识别)", @"localIdcardOCROnlineFront"]];
    [self.actionList addObject:@[@"身份证反面(嵌入式质量控制+云端识别)", @"localIdcardOCROnlineBack"]];
    [self.actionList addObject:@[@"银行卡正面拍照识别", @"bankCardOCROnline"]];
}



- (void)updateTableView {
    [self.tableView reloadData];
}

- (void)alertMessage:(NSString *)title message:(NSString *) msg{
    __weak typeof(self) weakSelf = self;
    dispatch_async(dispatch_get_main_queue(), ^{
        UIAlertController *alert  = [UIAlertController alertControllerWithTitle:title message:msg preferredStyle:UIAlertControllerStyleAlert];
        [alert addAction:[UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:nil]];
        [[UIApplication sharedApplication].keyWindow.rootViewController.presentedViewController dismissViewControllerAnimated:YES completion:nil];
        [weakSelf presentViewController:alert animated:YES completion:nil];
    });
}

#pragma mark - Action

/// 身份证正面拍照识别
- (void)idcardOCROnlineFront {
    
    UIViewController * vc =
    [AipCaptureCardVC ViewControllerWithCardType:CardTypeIdCardFont andImageHandler:^(UIImage *image) {
        @try {
            IdCardFrontResponse *response = [[AipOcrService shardService] detectIdCardFrontFromImage:image];
            NSString *resultStr =  [[NSString alloc]initWithFormat: @"姓名:%@\n性别:%@\n民族:%@\n证件号码:%@\n出生日期:%@\n地址:%@",response.name,response.sex,response.nation,response.idNum,response.birth,response.address];
            [self alertMessage:@"扫描结果" message: resultStr];
        } @catch (NSError *err) {
            NSLog(@"%@",err);
            NSString *msg = [NSString stringWithFormat:@"%li:%@", (long)[err code], [err localizedDescription]];
            [self alertMessage:@"识别失败" message:msg];
        }
    }];
    
    [self presentViewController:vc animated:YES completion:nil];
    
}

/// 身份证正面(嵌入式质量控制+云端识别)
- (void)localIdcardOCROnlineFront {
    
    UIViewController * vc =
    [AipCaptureCardVC ViewControllerWithCardType:CardTypeLocalIdCardFont andImageHandler:^(UIImage *image) {
        @try {
            IdCardFrontResponse *response = [[AipOcrService shardService] detectIdCardFrontFromImage:image];
            NSString *resultStr =  [[NSString alloc]initWithFormat: @"姓名:%@\n性别:%@\n民族:%@\n证件号码:%@\n出生日期:%@\n地址:%@",response.name,response.sex,response.nation,response.idNum,response.birth,response.address];
            [self alertMessage:@"扫描结果" message: resultStr];
        } @catch (NSError *err) {
            NSLog(@"%@",err);
            NSString *msg = [NSString stringWithFormat:@"%li:%@", (long)[err code], [err localizedDescription]];
            [self alertMessage:@"识别失败" message:msg];
        }
    }];
    [self presentViewController:vc animated:YES completion:nil];
    
    
}

/// 身份证反面拍照识别
- (void)idcardOCROnlineBack{
    
    UIViewController * vc =
    [AipCaptureCardVC ViewControllerWithCardType:CardTypeIdCardBack andImageHandler:^(UIImage *image) {
        @try {
            IdCardBackResponse *response = [[AipOcrService shardService] detectIdCardBackFromImage:image];
            NSString *resultStr =  [[NSString alloc]initWithFormat: @"发证机关:%@\n有效期:%@",response.authority,response.validDate];
            [self alertMessage:@"扫描结果" message: resultStr];
        } @catch (NSError *err) {
            NSLog(@"%@",err);
            NSString *msg = [NSString stringWithFormat:@"%li:%@", (long)[err code], [err localizedDescription]];
            [self alertMessage:@"识别失败" message:msg];
        }
    }];
    [self presentViewController:vc animated:YES completion:nil];
}

/// 身份证反面(嵌入式质量控制+云端识别)
- (void)localIdcardOCROnlineBack{
    
    UIViewController * vc =
    [AipCaptureCardVC ViewControllerWithCardType:CardTypeLocalIdCardBack andImageHandler:^(UIImage *image) {
        @try {
            IdCardBackResponse *response = [[AipOcrService shardService] detectIdCardBackFromImage:image];
            NSString *resultStr =  [[NSString alloc]initWithFormat: @"发证机关:%@\n有效期:%@",response.authority,response.validDate];
            [self alertMessage:@"扫描结果" message: resultStr];

        } @catch (NSError *err) {
            NSLog(@"%@",err);
            NSString *msg = [NSString stringWithFormat:@"%li:%@", (long)[err code], [err localizedDescription]];
            [self alertMessage:@"识别失败" message:msg];
        }
    }];
    [self presentViewController:vc animated:YES completion:nil];
}

/// 银行卡正面拍照识别
- (void)bankCardOCROnline{
    
    UIViewController * vc =
    [AipCaptureCardVC ViewControllerWithCardType:CardTypeBankCard andImageHandler:^(UIImage *image) {
        @try {
            BankCardResponse * response = [[AipOcrService shardService] detectBankCardFromImage:image];
            NSString *resultStr =  [[NSString alloc]initWithFormat: @"银行卡信息:%@\n卡号:%@\n有效期:%@",response.bankInfo,response.cardNo,response.validDate];
            [self alertMessage:@"扫描结果" message: resultStr];
        } @catch (NSError *err) {
            NSLog(@"%@",err);
            NSString *msg = [NSString stringWithFormat:@"%li:%@", (long)[err code], [err localizedDescription]];
            [self alertMessage:@"识别失败" message:msg];
        }
    }];
    [self presentViewController:vc animated:YES completion:nil];
    
}

- (void)mockBundlerIdForTest {
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wundeclared-selector"
    [self mockClass:[NSBundle class] originalFunction:@selector(bundleIdentifier) swizzledFunction:@selector(sapicamera_bundleIdentifier)];
#pragma clang diagnostic pop
}

- (void)mockClass:(Class)class originalFunction:(SEL)originalSelector swizzledFunction:(SEL)swizzledSelector {
    
    Method originalMethod = class_getInstanceMethod(class, originalSelector);
    Method swizzledMethod = class_getInstanceMethod(class, swizzledSelector);
    
    BOOL didAddMethod = class_addMethod(class, originalSelector, method_getImplementation(swizzledMethod), method_getTypeEncoding(swizzledMethod));
    
    if (didAddMethod) {
        class_replaceMethod(class, swizzledSelector, method_getImplementation(originalMethod), method_getTypeEncoding(originalMethod));
    } else {
        method_exchangeImplementations(originalMethod, swizzledMethod);
    }
    
}

#pragma mark - UITableViewDelegate & UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return self.actionList.count;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    
    return 1;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    UITableViewCell *cell = nil;
    
    NSArray *actions = self.actionList[indexPath.row];
    cell = [tableView dequeueReusableCellWithIdentifier:@"DemoActionCell" forIndexPath:indexPath];
    cell.textLabel.text = actions[0];
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    if (indexPath.section == 0) {
        return 55;
    } else {
        return 44;
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    SEL funSel = NSSelectorFromString(self.actionList[indexPath.row][1]);
    if (funSel) {
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Warc-performSelector-leaks"
        [self performSelector:funSel];
#pragma clang diagnostic pop
    }
}

-(BOOL)shouldAutorotate{
    return NO;
}

- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    return UIInterfaceOrientationMaskPortrait;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}


@end
