//
//  TtsView.swift
//  CepmApp
//
//  Created by 康伟丁 on 2021/1/5.
//

import SwiftUI
import AVFoundation
import cepmSdk
struct TtsView: View {
    @State private var txt = ""
    @State private var showAlert:Bool = false
    @State private var errMsg = ""
    @State private var errCode = -1
    var body: some View {
        var audio:AVAudioPlayer = AVAudioPlayer()
        TextField("待合成文本", text: $txt)
            .padding()
            .overlay(RoundedRectangle(cornerRadius: 20).stroke(Color.blue, lineWidth: 5))
            .padding()
        Button(action: {
                let credential = Credential();
                credential.sysName = "jkrf"
                credential.password = "xrwZD376AXHDgWde6s2bkZ6P7TaexhzAja7XoOMX8nOq3TaDqFHi73fAuBMj04lu9TvDTD1HhKQHRTcoRDxgCXvFwtF9+6kj5UUsH9A8NiEBh8MuVjQC61qV7cM9j2gH+myeWBEInCHOsJXDrB7ADxLrZMuIG+feoGwsEw7xyVI="
                credential.userCode = "v001"
                credential.url = "https://cepmtest.dhcccloud.com.cn/gateway"
                let request = TtsRequest()
                request.text = txt
            let client = DhccTtsClient(credential: credential)
                let response:TtsResponse = try! client.doTts(request: request)
                print(response.toJSONString())
            if response.errcode != 0 {
                self.errMsg = response.errmsg!
                self.errCode = response.errcode
                self.showAlert = true
                return
            }
            audio = client.play(response: response)
            audio.prepareToPlay()
            audio.play()
        }, label: {
            Text("测试声音合成")
        }).alert(isPresented: $showAlert, content: {
            Alert(title: Text("异常"), message: Text(self.errMsg), dismissButton: Alert.Button.cancel(Text("确定")))
//            let alert:UIAlertController = UIAlertController(title: "失败", message: $errMsg, preferredStyle: .alert)
//            let okAction:UIAlertAction = UIAlertAction(title: "好的", style: .default, handler: nil)
//            alert.addAction(okAction)
        })
    }
}

struct TtsView_Previews: PreviewProvider {
    static var previews: some View {
        TtsView()
    }
}
