//
//  CepmHttpClient.swift
//  CepmApp
//
//  Created by 楚海 on 2020/12/28.
//

import Foundation
import Alamofire

public class CepmHttlClient{
    public var token:String
    
    public init(token:String) {
        self.token = token
    }
    
    /// Post请求
    /// - Parameters:
    ///   - url: 请求地址
    ///   - params: 请求参数
    /// - Returns: 返回请求对象
    public func postJson<T:BaseEntry>(_ url:String,params:[String:Any]) -> T? {
        let headers: HTTPHeaders = [
            .contentType("application/json"),
            .accept("application/json"),
            .authorization(token)
        ]
        
        return HttpUtils.doPostSyn(url, params: params, headers: headers)
    }
    
    /// form请求
    /// - Parameters:
    ///   - url: 请求地址
    ///   - params: 请求参数
    /// - Returns: 返回请求对象
    public func postForm<T:BaseEntry>(_ url:String,params:[String:Any]) -> T? {
        let headers: HTTPHeaders = [
            .contentType("application/x-www-form-urlencoded"),
            .accept("application/json"),
            .authorization(token)
        ]
        
        return HttpUtils.doPostSyn(url, params: params, headers: headers)
    }
    
    /// Get请求
    /// - Parameters:
    ///   - url: 请求地址
    ///   - params 请求参数
    /// - Returns: 返回请求对象
    public func getRequest<T:BaseEntry>(_ url:String,params:[String:Any]) -> T? {
        let headers: HTTPHeaders = [
            .authorization(token)
        ]
        
        return HttpUtils.doPostSyn(url, params: params, headers: headers)
    }
}
