//
//  DateExtension.swift
//  CepmApp
//
//  Created by 楚海 on 2020/12/28.
//

import Foundation

extension Date{
    
     static var currentDate : Date {
        return Self()
    }
    
    func timeOffset(dateType:DateType = .second)->Double{
        let timeInterval = fabs(Date().timeIntervalSince(self))
        return timeInterval/dateType.calBasis
    }
    
    func compareOffset(_ offset:Double,dateType:DateType = .second) -> Int {
        let res = timeOffset(dateType:dateType)
        if res > offset {return 1}
        if res == offset {return 0}
        return -1
    }
}

public struct DateType {
    
    static let  second = DateType(1)
    static let mimute = DateType(60)
    static let hours = DateType(3600)
    static let day = DateType(86400)
    
    var calBasis:Double
    
    init(_ calBasis:Double){
        self.calBasis = calBasis
    }
}
